// chard.c

#pragma save_binary

inherit F_CLEAN_UP;

void create() { seteuid(getuid()); }

// setup_char()
//
// This function is called when characters need setup (after create() is
// called). The major task of this function is to keep consistency of
// user data and NPCs. Because the game system may change with development
// of mudlib, there might be minor or major changes in creating character
// objects. Also, this function serves as default creation function of 
// NPCs that saves wizards' work on initializing NPCs.

void setup_char(object ob)
{
		
	if( !ob->query_race() )		ob->set_race("human");
	if( !ob->query_class() )	ob->set_class("commoner");
	if( !ob->query_level() )	ob->set_level(1);

	RACE_D(ob->query_race())->setup(ob);
	CLASS_D(ob->query_class())->setup(ob);

	ob->set("time_unit", (: call_other, ob, "query_attr", "dex" :));

	ob->reset_action();
}

varargs object make_corpse(object victim, object killer)
{
	int i, apparition;
	object corpse, *inv;
	string corpse_ob;

	// Ghosts don't leave a corpse.
	if( victim->is_ghost() ) {
		all_inventory(victim)->owner_is_killed(killer);
		inv = all_inventory(victim);
		i = sizeof(inv);
		while(i--) inv[i]->move(environment(victim));
		return 0;
	}

	if( !stringp(corpse_ob = victim->query("corpse_ob")) )
		corpse_ob = CORPSE_OB;

	seteuid(MUDLIB_UID);
	corpse = new(corpse_ob);
	seteuid(getuid());

	corpse->set_name( victim->name(1) + "", ({ "corpse" }) );
	corpse->set("long", victim->long()
		+ "MӡM" + gender_pronoun(victim->query("gender")) 
		+ "wgFMuѤU@RRabo̡C\n");
	corpse->set("age", victim->query("age"));
	corpse->set("gender", victim->query("gender"));
	corpse->set("victim_name", victim->name(1));
	corpse->set_weight( victim->query_weight() );
	corpse->set_max_encumbrance( victim->query_max_encumbrance() );
	corpse->move(environment(victim));
	
	// Don't let wizard left illegal items in their corpses.
	if( !wizardp(victim) ) {
		all_inventory(victim)->owner_killed(killer);
		inv = all_inventory(victim);
		i = sizeof(inv);
		while(i--) {
			if( (string)inv[i]->query("equipped")=="worn" ) {
				inv[i]->move(corpse);
				if( !inv[i]->wear() ) inv[i]->move(environment(victim));
			}
			else inv[i]->move(corpse);
		}
	}

	return corpse;
}
